;
;*******************************************************
;*******************************************************
;**                                                   **
;**                                                   **
;**           Modul obslugi wyswietlacza              **
;**                                                   **
;**       7 segmentowego, wspolna anoda, 6 cyfr       **
;**                                                   **
;**            Napisal: Andrzej Pawluczuk             **
;**                                                   **
;**               Mikrokontroler: AVR                 **
;**                                                   **
;*******************************************************
;*******************************************************
;
.message	"***>>> Dolaczenie bibioteki obslugi wyswietlacza LED (7 segm)"
;-----------------------------------------------------------------------------
.equ	_LED_SegData_DirPort	= LED_SegData_Port - 1
.equ	_LED_SelDigit_DirPort	= LED_SelDigit_Port - 1
;-----------------------------------------------------------------------------
.equ	DisplaySize		= 6
;-----------------------------------------------------------------------------
.equ	Ch0Code			= 0b00111111
.equ	Ch1Code			= 0b00000110
.equ	Ch2Code			= 0b01011011
.equ	Ch3Code			= 0b01001111
.equ	Ch4Code			= 0b01100110
.equ	Ch5Code			= 0b01101101
.equ	Ch6Code			= 0b01111101
.equ	Ch7Code			= 0b00000111
.equ	Ch8Code			= 0b01111111
.equ	Ch9Code			= 0b01101111
.equ	ChPointCode		= 0b10000000
.equ	ChMinusCode		= 0b01000000
;-----------------------------------------------------------------------------
	.dseg
;						;VAR
_DisplayBuffer:	.byte	DisplaySize		; _DisplayBuffer : ARRAY [ 0 .. DisplaySize - 1 ] OF BYTE ;
_RfshIndex:	.byte	1			; _RfshIndex : BYTE ;
_WritePos:	.byte	1			; _WritePos : BYTE ;
;-----------------------------------------------------------------------------
	.cseg
;-----------------------------------------------------------------------------
Init7SegmEnvir :				;PROCEDURE Init7SegmEnvir ( ) ;
;*************					;BEGIN (* Init7SegmEnvir *)
	ldi	acc,0xFF			; [LED_SegData_Port] := [output] ;
	out	_LED_SegData_DirPort,acc	;
	out	_LED_SelDigit_DirPort,acc	; [LED_SelDigit_Port] := [output] ;
	ldi	acc,0				; _RfshIndex := 0 ;
	sts	_RfshIndex,acc			;
	rcall	LEDClearDisplay			; LEDClearDisplay ( ) ;
	ret					;END (* Init7SegmEnvir *) ;
;-----------------------------------------------------------------------------
LEDDisplTimeService :				;PROCEDURE LEDDisplTimeService  ;
;****************				;BEGIN (* LEDDisplTimeService *)
	push	r0				;
	ldi	acc,0xFF			; [LED_SelDigit_Port] := 0xFF ;
	out	LED_SelDigit_Port,acc		;
	ldz	_DisplayBuffer			; [LED_SegData_Port] := _DisplayBuffer [ _RfshIndex ] ;
	lds	acc,_RfshIndex			;
	add	zl,acc				;
	ldi	acc,0				;
	adc	zh,acc				; 
	ld	acc,z				;
	out	LED_SegData_Port,acc		;
	ldz	_SelDigitControl<<1		; [LED_SelDigit_Port] := _SelDigitControl [ _RfshIndex ] ;
	lds	acc,_RfshIndex			;
	add	zl,acc				;
	ldi	acc,0				;
	adc	zh,acc				;
	lpm					;
	out	LED_SelDigit_Port,r0		;
	ldz	_RfshIndex			; _RfshIndex := _RfshIndex + 1 ;
	ld	acc,z				;
	inc	acc				;
	st	z,acc				;
	cpi	acc,DisplaySize			; IF _RfshIndex = DisplaySize THEN
	brne	LDisplTS_0			; BEGIN
	ldi	acc,0				;  _RfshIndex := 0 ;
	st	z,acc				;
LDisplTS_0 :					; END (* IF *) ;
	pop	r0				;
	ret					;END (* LEDDisplTimeService *) ;
;-----------------------------------------------------------------------------
LEDClearDisplay :				;PROCEDURE LEDClearDisplay ( ) ;
;						; VAR
;						;  Inx[acc2] : BYTE ;
;****************				;BEGIN (* LEDClearDisplay *)
	ldi	acc2,0				; FOR Inx := 0 TO DisplaySize - 1 DO
	ldz	_DisplayBuffer			;
	ldi	acc,0				;
ClrLD7S_0 :					; BEGIN
	st	z+,acc				;  _DisplayBuffer [ Inx ] := 0 ;
	inc	acc2				;
	cpi	acc2,DisplaySize		;
	brne	ClrLD7S_0			; END (* FOR *) ;
	sts	_WritePos,acc			; _WritePos := 0 ;
	ret					;END (* LEDClearDisplay *) ;
;-----------------------------------------------------------------------------
IncrementPos :					;PROCEDURE IncrementPos ( ) ;
;*************					;BEGIN (* IncrementPos *)
	ldz	_WritePos			; _WritePos := _WritePos + 1 ;
	ld	acc,z				;
	inc	acc				;
	st	z,acc				;
	cpi	acc,DisplaySize			; IF _WritePos = DisplaySize THEN
	brne	IncPoLD7S_0			; BEGIN
	ldi	acc,0				;  _WritePos := 0 ;
	st	z,acc				;
IncPoLD7S_0 :					; END (* IF *) ;
	ret					;END (* IncrementPos *)
;-----------------------------------------------------------------------------
EncodeChar :					;FUNCTION EncodeChar ( Ch[aparm] : CHAR ) : BYTE[acc] ;
;						;TYPE
;						; EncodeTableElementType = RECORD
;						;			     ChPatt : CHAR ;
;						;			     Code   : BYTE ;
;						;			   END (* RECORD *) ;
;						;VAR
;						; ChPtr[z] : POINTER TO CHAR ;
;						;BEGIN (* EncodeChar *)
	ldz	EncodeTable<<1			; ChPtr := ADR ( EncodeTable ) ;
EncChLD7S_2 :					; LOOP
	lpm					;  IF ChPtr ^ . ChPatt = 0 THEN
	ldi	acc,0				;
	cp	acc,r0				;
	brne	EncChLD7S_0			;  BEGIN
	ldi	acc,0				;   EncodeChar := 0 ;
	ret					;   RETURN ;
EncChLD7S_0 :					;  END (* IF *) ;
	cp	r0,param			;  IF ChPtr ^ . ChPatt = Ch THEN
	brne	EncChLD7S_1			;  BEGIN
	adiw	zl,1				;   EncodeChar := ChPtr ^ . Code ;
	lpm					;
	mov	acc,r0				;
	ret					;   RETURN ;
EncChLD7S_1 :					;  END (* IF *) ;
	adiw	zl,2				;  ChPtr := succ ( ChPtr ) ;
	rjmp	EncChLD7S_2			; END (* LOOP *) ;
						;END (* EncodeChar *) ;
;-----------------------------------------------------------------------------
LEDDisplWriteCode :				;PROCEDURE LEDDisplWriteCode ( Ch[param] : BYTE ) ;
;******************				;BEGIN (* LEDDisplWriteCode *)
	ldz	_DisplayBuffer			; _DisplayBuffer [ _WritePos ] := Ch ;
	lds	acc,_WritePos			;
	add	zl,acc				;
	ldi	acc,0				;
	adc	zh,acc				;
	st	z,param				;
	rcall	IncrementPos			; IncrementPos ( ) ;
	ret					;END (* LEDDisplWriteCode *) ;
;-----------------------------------------------------------------------------
LEDDisplWriteCh :				;PROCEDURE LEDDisplWriteCh ( Ch[param] : CHAR ) ;
;						;VAR
;						; Code[acc] : BYTE ;
;****************				;BEGIN (* LEDDisplWriteCh *)
	rcall	EncodeChar			; Code := EncodeChar ( Ch ) ;
	ldz	_DisplayBuffer			; _DisplayBuffer [ _WritePos ] := Code ;
	lds	acc2,_WritePos			;
	add	zl,acc2				;
	ldi	acc2,0				;
	adc	zh,acc2				;
	st	z,acc				;
	rcall	IncrementPos			; IncrementPos ( ) ;
	ret					;END (* LEDDisplWriteCh *) ;
;-----------------------------------------------------------------------------
LEDDisplSetPos :				;PROCEDURE LEDDisplSetPos ( Pos[param] : BYTE ) ;
;***************				;BEGIN (* LEDDisplSetPos *)
	cpi	param,DisplaySize		; IF Pos >= DisplaySize THEN
	brcs	SetPosLD7S_0			; BEGIN
	ldi	param,0				;  Pos := 0 ;
SetPosLD7S_0 :					; END (* IF *) ;
	sts	_WritePos,param			; _WritePos := Pos ;
	ret					;END (* LEDDisplSetPos *) ;
;-----------------------------------------------------------------------------
_SelDigitControl:	.db	0b11111110 , 0b11111101
			.db	0b11111011 , 0b11110111
			.db	0b11101111 , 0b11011111
			.db	0b10111111 , 0b01111111
;-----------------------------------------------------------------------------
EncodeTable :		.db	'0' , Ch0Code
			.db	'1' , Ch1Code
			.db	'2' , Ch2Code
			.db	'3' , Ch3Code
			.db	'4' , Ch4Code
			.db	'5' , Ch5Code
			.db	'6' , Ch6Code
			.db	'7' , Ch7Code
			.db	'8' , Ch8Code
			.db	'9' , Ch9Code
			.db	0   , 0000000000
;-----------------------------------------------------------------------------
.exit
