;
;*******************************************************
;*******************************************************
;**                                                   **
;**    Biblioteka procedur obslugi klawiatury         **
;**                                                   **
;**               Andrzej Pawluczuk                   **
;**                                                   **
;**              Mikrokontroler: AVR                  **
;**                                                   **
;**                Bialystok, 2006                    **
;**                                                   **
;*******************************************************
;*******************************************************
;
;-----------------------------------------------------------------------------
.equ	KeybIdle	= 0x00
.equ	KeybWaitOnPress	= 0x01
.equ	KeybReady	= 0x02
.equ	KeybActive	= 0x03
.equ	KeybWaitOnFree	= 0x04
.equ	KeybDelayLimit	= 0x10
;-----------------------------------------------------------------------------
	.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;						;
;						; VAR
KeybStatus 	:	.byte	1		;  KeybStatus : BYTE ;
KeybCode	:	.byte	1		;  KeybCode : BYTE ;
KeybDelayCt	:	.byte	1		;  KeybDelayCt : BYTE ;
;-----------------------------------------------------------------------------
	.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;-----------------------------------------------------------------------------
KeybSoftInit :					;PROCEDURE KeybSoftInit ;
;*************					;BEGIN (* KeybSoftInit *)
	ldi	acc,0				; KeybDelayCt := 0 ;
	sts	KeybDelayCt,acc			;
	ldi	acc,KeybIdle			; KeybStatus := KeybIdle ;
	sts	KeybStatus,acc			;
	ret					;END KeybSoftInit ;
;-----------------------------------------------------------------------------
KeybService :					;PROCEDURE KeybService ( ) ;
;************					;BEGIN
	push	acc2				;
	ldz	KeybStatus			; CASE KeybStatus OF
	ld	acc,z				;
	cpi	acc,KeybIdle			; KeybIdle :
	brne	KeybS_1				;  BEGIN
	rcall	AnyKeyActive			;   IF AnyKeyActive ( ) THEN
	brcc	KeybS_11			;   BEGIN
	ldi	acc,KeybWaitOnPress		;    KeybStatus := KeybWaitOnPress ;
	st	z,acc				;
	ldi	acc,KeybDelayLimit		;    KeybDelayCt := KeybDelayLimit ;
	sts	KeybDelayCt,acc			;
KeybS_11 :					;   END (* IF *) ;
	rjmp	KeybS_0				;  END (* CASE VARIANT *)
KeybS_1		:				;
	cpi	acc,KeybWaitOnPress		; KeybWaitOnPress :
	brne	KeybS_2				;  BEGIN
	ldz	KeybDelayCt			;   KeybDelayCt := KeybDelayCt - 1 ;
	ld	acc,z				;
	dec	acc				;
	st	z,acc				;
	cpi	acc,0				;   IF KeybDelayCt = 0 THEN
	brne	KeybS_21			;   BEGIN
	rcall	AnyKeyActive			;    IF AnyKeyActive ( ) THEN
	brcc	KeybS_22			;    BEGIN
	ldi	acc,KeybReady			;     KeybStatus := KeybReady ;
	sts	KeybStatus,acc			;
	rjmp	KeybS_23			;    END (* IF ... *)
KeybS_22 :					;    ELSE
						;    BEGIN
	ldi	acc,KeybIdle			;     KeybStatus := KeybIdle ;
	sts	KeybStatus,acc			;
KeybS_23 :					;    END (* IF ... ELSE *) ;
KeybS_21 :					;   END (* IF *) ;
	rjmp	KeybS_0				;  END (* CASE VARIANT *)
KeybS_2	:					;
	cpi	acc,KeybReady			; KeybReady :
	brne	KeybS_3				;  BEGIN
	ldi	acc,KeybActive			;   KeybStatus := KeybActive ;
	st	z,acc				;
	rcall	DecodeKey			;   DecodeKey ( ) ;
	rjmp	KeybS_0				;  END (* CASE VARIANT *)
KeybS_3	:					;
	cpi	acc,KeybActive			; KeybActive :
	brne	KeybS_4				;  BEGIN
	rcall	AnyKeyActive			;   IF NOT AnyKeyActive ( ) THEN
	brcs	KeybS_41			;   BEGIN
	ldi	acc,KeybWaitOnFree		;    KeybStatus := KeybWaitOnFree ;
	st	z,acc				;
	ldi	acc,KeybDelayLimit		;    KeybDelayCt := KeybDelayLimit ;
	sts	KeybDelayCt,acc			;
KeybS_41 :					;   END (* IF *) ;
	rjmp	KeybS_0				;  END (* CASE VARIANT *)
KeybS_4	:					;
	cpi	acc,KeybWaitOnFree		; KeybWaitOnFree :
	brne	KeybS_5				;  BEGIN
	ldz	KeybDelayCt			;   KeybDelayCt := KeybDelayCt - 1 ;
	ld	acc,z				;
	dec	acc				;
	st	z,acc				;
	cpi	acc,0				;   IF KeybDelayCt = 0 THEN
	brne	KeybS_51			;   BEGIN
	ldi	acc,KeybIdle			;    KeybStatus := KeybIdle ;
	sts	KeybStatus,acc			;
KeybS_51 :					;   END (* IF *) ;
	rjmp	KeybS_0				;  END (* CASE VARIANT *)
KeybS_5	:					; ELSE
						;  BEGIN
						;  END (* CASE ELSE VARIANT *)
KeybS_0	:					; END (* CASE *) ;
	pop	acc2				;
	ret					;END (* KeybService *) ;
;-----------------------------------------------------------------------------
StoreKey :					;PROCEDURE StoreKey ( Key [acc] : CHAR ) ;
;*********					;BEGIN
	sts	KeybCode,acc			; KeybCode := Temp ;
	ret					;END (* StoreKey *) ;
;-----------------------------------------------------------------------------
KeyPressed :					;FUNCTION KeyPressed ( ) : BOOLEAN [C] ;
;***********					;BEGIN
	lds	acc,KeybCode			; RETURN ( KeybCode <> 0 ) ;
	cpi	acc,0				;
	breq	KeyPr_0				;
	sec					;
	ret					;
KeyPr_0	:					;
	clc					;
	ret					;END (* KeyPressed *) ;
;-----------------------------------------------------------------------------
ReadKey		:				;FUNCTION ReadKey ( ) : CHAR [acc] ;
;****************				; VAR
;						;  Temp [acc] : CHAR ;
						;BEGIN
	ldz	KeybCode			; Temp := KeybCode ;
	ld	acc,z				;
	ldi	acc2,0				; KeybCode := 0 ;
	st	z,acc2				;
						; ReadKey := Temp ;
	ret					;END (* ReadKey *) ;
;-----------------------------------------------------------------------------
.exit
