;
;*******************************************************
;*******************************************************
;**                                                   **
;**   Program prezentacji obslugi wielopoziomowego    **
;**                    menu                           **
;**                                                   **
;**         Andrzej Pawluczuk                         **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
.endm
;-----------------------------------------------------------------------------
.macro	ldx
	ldi	xl,low(@0)			;
	ldi	xh,high(@0)			;
.endm
;-----------------------------------------------------------------------------
.macro	pushz
	push	zl				;
	push	zh				;
.endm
;-----------------------------------------------------------------------------
.macro	popz
	pop	zh				;
	pop	zl				;
.endm
;-----------------------------------------------------------------------------
.macro	pushf
	push	acc				;
	in	acc,sreg			;
	push	acc				;
.endm
;-----------------------------------------------------------------------------
.macro	popf
	pop	acc				;
	out	sreg,acc			;
	pop	acc				;
.endm
;-----------------------------------------------------------------------------
.macro	incvar
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ldi	acc2,@1				;
	ld	acc,z				;
	add	acc,acc2			;
	st	z+,acc				;
	ld	acc,z				;
	ldi	acc2,0				;
	adc	acc,acc2			;
	st	z,acc				;
.endm
;uzycie
;	incvar	<zmienna w RAM typu WORD>,<o ile zwiekszyc>
;	incvar	LowerBound,1
;-----------------------------------------------------------------------------
.macro	decvar
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ld	acc,z				;
	subi	acc,@1				;
	st	z+,acc				;
	ld	acc,z				;
	sbci	acc,0				;
	st	z,acc				;
.endm
;uzycie
;	decvar	<zmienna w RAM typu WORD>,<o ile zmniejszyc>
;	decvar	LowerBound,1
;-----------------------------------------------------------------------------
.macro	assignv
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ldi	acc,low(@1<<1)			;
	st	z+,acc				;
	ldi	acc,high(@1<<1)			;
	st	z,acc				;
.endm
;uzycie
;	assignv	<zmienna RAM>,<obszar we FLASH>
;przyklad
;	assignv	MenuTextEntry,BoundMenuText	; MenuTextEntry[0]:=ADR(BoundMenuText);
;-----------------------------------------------------------------------------
.macro	assvc
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ldi	acc,low(@1)			;
	st	z+,acc				;
	ldi	acc,high(@1)			;
	st	z,acc				;
.endm
;uzycie
;	assvc	<zmienna RAM>,<stala>
;przyklad
;	assvc	LowerBound,LoDefault		; LowerBound := LoDefault ;
;-----------------------------------------------------------------------------
.macro	cpyword
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ld	acc,z+				;
	ld	acc2,z+				;
	st	z+,acc				;
	st	z+,acc2				;
.endm
;makroinstrukcja przepisuje zawartosc zmiennej (typu WORD - 2 bajty)
;o dwa bajty dalej (pod nastepny index)
;	cpyword	<zmienna typu WORD>
;przyklad
;	ldz	MenuTextEntry+4			; MenuTextEntry [ 3 ] := MenuTextEntry [ 2 ] ;
;-----------------------------------------------------------------------------
.def DivLoopCounter	= r1
.def Argument1LL	= r2
.def Argument1LH	= r3
.def Argument1HL	= r4
.def Argument1HH	= r5
.def Argument2LL	= r6
.def Argument2LH	= r7
.def Argument2HL	= r8
.def Argument2HH	= r9
.def WorkRegLL		= r10
.def WorkRegLH		= r11
.def WorkRegHL		= r12
.def WorkRegHH		= r13
.def acc		= r16
.def acc2		= r17
.def param		= r18
.def ResultLL		= r22
.def ResultLH		= r23
.def ResultHL		= r24
.def ResultHH		= r25
;-----------------------------------------------------------------------------
.equ		Stand_TIMSK	=	0b00000010
;	Timer/counter Interrupt Mask	  ||| | |
;					  ||| | +--- TOIE0 : Timer/Counter 0 Overflow Interrupt Enable
;					  ||| +----- TICIE1 : Timer/Counter1 Input Capture Interrupt Enable
;					  ||+------- OCIE1B : Timer/counter1 Output Compare B Match Interrupt Enable
;					  |+-------- OCE1A : Timer/counter1 Output Compare A Match Interrupt Enable
;					  +--------- TOIE1 : Timer/Counter1 Overflow Interrupt Enable
;-----------------------------------------------------------------------------
.equ		Stand_TCCR0	=	0b00000011
;	Timer/Counter0 Control Register	       |||
;					       ||+-- CS00
;					       |+--- CS01
;					       +---- CS02
;		CS02	CS01	CS00
;		0	0	0	timer/counter0 is stopped
;		0	0	1	clk
;		0	1	0	clk/8
;		0	1	1	clk/64
;		1	0	0	clk/256
;		1	0	1	clk/1024
;		1	1	0	external pin T0; falling edge
;		1	1	1	external pin T0; rising edge
;-----------------------------------------------------------------------------
.equ		Stand_PADir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PAData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PBDir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PBData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PCDir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PCData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PDDir	=	0b11111110
;					  ||||||||
;					  |||||||+-- input :	[RXD]
;					  ||||||+--- output :	[TXD]
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PDData	=	0b11111111
;-----------------------------------------------------------------------------
	.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;					;CONST
.equ	Cr		= 0x0D		; Cr = 0x0D ;
.equ	Lf		= 0x0A		; Lf = 0x0A ;
.equ	Esc		= 0x1B		; Esc = 0x1B ;
.equ	LoDefault	= 200		; LoDefault = 200 ;
.equ	UpDefault	= 250		; UpDefault = 250 ;
;					;
;					;VAR
LowerBound :		.byte	2	; LowerBound : WORD ;
UpperBound :		.byte	2	; UpperCound : WORD ;
Number :		.byte	8	; Number : ARRAY [ 0 .. 7 ] OF CHAR ;
MenuTextEntry :		.byte	8	; MenuTextEntry : ARRAY [ 0 .. 3 ] OF POINTER TO CHAR ;
MenuCodeArray :		.byte	8	; MenuCodeArray : ARRAY [ 0 .. 3 ] OF POINTER TO CHAR ;
MenuServArray :		.byte	8	; MenuServArray : ARRAY [ 0 .. 3 ] OF POINTER TO PROCEDURE ( ) ;
RedisplayMenu :		.byte	1	; RedisplayMenu : BOOLEAN ;
;-----------------------------------------------------------------------------
	.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
	.org	INT0addr			;External Interrupt0 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT1addr			;External Interrupt1 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ICP1addr			;Input Capture1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Aaddr			;Output Compare1A Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Baddr			;Output Compare1B Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF1addr			;Overflow1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF0addr			;Overflow0 Interrupt Vector Address
	rjmp	TC0OvfInterrupt			;
;-----------------------------------------------------------------------------
	.org	SPIaddr				;SPI Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	URXCaddr			;USART Receive Complete Interrupt Vector Address
	rjmp	USARTRXDInterrupt		;
;-----------------------------------------------------------------------------
	.org	UDREaddr			;USART Data Register Empty Interrupt Vector Address
	rjmp	USARTDataRegEmptInterrupt	;
;-----------------------------------------------------------------------------
	.org	UTXCaddr			;USART Transmit Complete Interrupt Vector Address
	rjmp	USARTTXDInterrupt		;
;-----------------------------------------------------------------------------
	.org	ACIaddr				;Analog Comparator Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT2addr			;External Interrupt2 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC0addr				;Output Compare0 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ERDYaddr			;EEPROM Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	SPMaddr				;SPM complete Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
.include "util.inc"
;-----------------------------------------------------------------------------
.equ	USART_Speed	= 47	; USART BAUD Rate Generator fosc=7.3728 MHz , 9600 bps
.equ	USART_LED_Trace	= 1
.equ	TXDBuffSize	= 32
.equ	RXDBuffSize	= 16
.equ	RXDLED		= 7
.equ	TXDLED		= 6
.equ	USARTTracePort	= PORTD
.equ	LEDOnState	= 0
.include "usartlib.inc"
;-----------------------------------------------------------------------------
.include "arithmetic.inc"
;-----------------------------------------------------------------------------
.include "strings.inc"
;-----------------------------------------------------------------------------
HardwareInit :					;PROCEDURE HardwareInit ;
;*************					;BEGIN
	ldi	acc,Stand_TIMSK			; [TIMSK] := Stand_TIMSK ;
	out	TIMSK,acc			;
	ldi	acc,Stand_TCCR0			; [TCCR0] := Stand_TCCR0 ;
	out	TCCR0,acc			;
	ret					;END (* HardwareInit *) ;
;-----------------------------------------------------------------------------
EnvirInit :					;PROCEDURE EnvirInit ;
;**********					;BEGIN
	ldi	acc,Stand_PADir			; [DDRA] := Stand_PADir ;
	out	DDRA,Acc			;
	ldi	acc,Stand_PAData		; [PORTA] := Stand_PAData ;
	out	PORTA,acc			;
	ldi	acc,Stand_PBDir			; [DDRB] := Stand_PBDir ;
	out	DDRB,Acc			;
	ldi	acc,Stand_PBData		; [PORTB] := Stand_PBData ;
	out	PORTB,acc			;
	ldi	acc,Stand_PCDir			; [DDRC] := Stand_PCDir ;
	out	DDRC,Acc			;
	ldi	acc,Stand_PCData		; [PORTC] := Stand_PCData ;
	out	PORTC,acc			;
	ldi	acc,Stand_PDDir			; [DDRD] := Stand_PDDir ;
	out	DDRD,Acc			;
	ldi	acc,Stand_PDData		; [PORTD] := Stand_PDData ;
	out	PORTD,acc			;
	ldz	USART_Speed			; USARTHardwareInit ( USART_Speed ) ;
	rcall	USARTHardwareInit		;
	ret					;END (* EnvirInit *) ;
;-----------------------------------------------------------------------------
SoftwareInit :					;PROCEDURE SoftwareInit ;
;*************					;BEGIN
	rcall	SetDefaltParam			; SetDefaltParam ( ) ;
	ret					;END (* SoftwareInit *) ;
;-----------------------------------------------------------------------------
TC0OvfInterrupt :				;PROCEDURE TC0OvfInterrupt ;
;****************				;BEGIN
	pushf					;
	pushz					;
.if USART_LED_Trace == 1
	rcall	USARTTimeService		; USARTTimeService ( ) ;
.endif
	popz					;
	popf					;
	reti					;END (* TC0OvfInterrupt *) ;
;-----------------------------------------------------------------------------
InputKey :					;FUNCTION InputKey ( ) : CHAR[acc] ;
;***************				;BEGIN (* InputKey *)
InpKy_1	:					; REPEAT
	rcall	SerialDataPresent		; UNTIL SerialDataPresent ( ) ;
	brcc	InpKy_1				;
	rcall	GetSerial			; InputKey := GetSerial ( ) ;
	ret					;END InputKey ;
;-----------------------------------------------------------------------------
NewLine		:				;PROCEDURE NewLine ( ) ;
;****************				;BEGIN (* NewLine *)
	ldi	param,Cr			; SendSerial ( Cr ) ;
	rcall	SendSerial			;
	ldi	param,Lf			; SendSerial ( Lf ) ;
	rcall	SendSerial			;
	ret					;END NewLine ;
;-----------------------------------------------------------------------------
EscapeKey :					;PROCEDURE EscapeKey ( Key[param] : CHAR ) : BOOLEAN ;
;**********					;BEGIN (* EscapeKey *)
	cpi	param,Esc			; IF Key = Esc THEN
	brne	EsKe_0				; BEGIN
	sec					;  RETURN TRUE ;
	ret					;
EsKe_0	:					; END (* IF *) ;
	clc					; RETURN FALSE ;
	ret					;END EscapeKey ;
;-----------------------------------------------------------------------------
SetDefaltParam :				;PROCEDURE SetDefaltParam ( ) ;
;***************				;BEGIN (* SetDefaltParam *)
	assvc	LowerBound,LoDefault		; LowerBound := LoDefault ;
	assvc	UpperBound,UpDefault		; UpperBound := UpDefault ;
	ret					;END (* SetDefaltParam *) ;
;-----------------------------------------------------------------------------
FindByteInArr :					;PROCEDURE FindByteInArr ( Data [param] : BYTE ;
;****************			   	;		Array [z] : ARRAY OF BYTE ) : BYTE[acc] ;
;						;VAR
;						; Loop[acc2] : BYTE ;
;						; Ch[acc] : CHAR ;
;						;BEGIN (* FindByteInArr *)
	clr	acc2				; Loop := 0 ;
FiByIA_2 :					; REPEAT
	lpm					;  Ch := Array [ Loop ] ;
	mov	acc,r0				;
	cpi	acc,0xFF			;  IF Ch = 0x0FF THEN
	brne	FiByIA_0			;  BEGIN
	ldi	acc,0xFF			;   RETURN 0xFF ;
	ret					;
FiByIA_0 :					;  END (* IF *) ;
	cp	acc,param			;  IF Ch = Data THEN
	brne	FiByIA_1			;  BEGIN
	mov	acc,acc2			;   RETURN Loop ;
	ret					;
FiByIA_1 :					;  END (* IF *) ;
	adiw	zl,1				;
	inc	acc2				;
	rjmp	FiByIA_2			; UNTIL FALSE ;
						;END (* FindByteInArr *) ;
;-----------------------------------------------------------------------------
RunService :					;PROCEDURE RunService ( Inx [param] ; BYTE :
;****************				;			Serv [z] : ADDRESS ) ;
;						;BEGIN (* RunService *)
	lsl	param				; Serv [ Inx ] ( ) ;
	clr	acc				;
	add	zl,param			;
	adc	zh,acc				;
	lpm					;
	push	r0				;
	adiw	zl,1				;
	lpm					;
	mov	zh,r0				;
	pop	zl				;
	icall					;
	ret					;END (* RunService *) ;
;-----------------------------------------------------------------------------
RunMenuSerivce	:				;PROCEDURE RunMenuSerivce ( ) ;
;****************				;BEGIN (* RunMenuSerivce *)
	ldi	acc,1				; RedisplayMenu := TRUE ;
	sts	RedisplayMenu,acc		;
RuMeSe_0 :					; LOOP
	lds	acc,RedisplayMenu		;  IF RedisplayMenu THEN
	cpi	acc,0				;
	breq	RuMeSe_2			;  BEGIN
	ldx	MenuTextEntry			;   SendSerialFlashTxt ( MenuTextEntry [ 0 ] ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	rcall	SendSerialFlashTxt		;
	rcall	NewLine				;   NewLine ( ) ;
	ldi	acc,0				;   RedisplayMenu := FALSE ;
	sts	RedisplayMenu,acc		;
RuMeSe_2 :					;  END (* IF *) ;
	rcall	InputKey			;  Ch = InputKey ( ) ;
	mov	param,acc			;  IF EscapeKey ( Ch ) THEN
	rcall	EscapeKey			;
	brcc	RuMeSe_1			;  BEGIN
	ret					;   RETURN ;
RuMeSe_1 :					;  END (* IF *) ;
	ldx	MenuCodeArray			;  Inx = FindByteInArr ( Ch , MenuCodeArray ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	rcall	FindByteInArr			;
	cpi	acc,0xFF			;  IF Inx <> 0xFF THEN
	breq	RuMeSe_3			;  BEGIN
	ldx	MenuServArray			;   RunService ( Inx , MenuServArray ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	mov	param,acc			;
	rcall	RunService			;
	ldi	acc,1				;   RedisplayMenu := TRUE ;
	sts	RedisplayMenu,acc		;
RuMeSe_3 :					;  END (* IF *) ;
	rjmp	RuMeSe_0			; END (* LOOP *) ;
	ret					;END RunMenuSerivce ;
;-----------------------------------------------------------------------------
ModiBoundOptSrv :				;PROCEDURE ModiBoundOptSrv ( ) ;
;****************				;BEGIN (* ModiBoundOptSrv *)
	rcall	OpenMenuLevel			; OpenMenuLevel ( ) ;
	assignv	MenuTextEntry,BoundMenuText	; MenuTextEntry [ 0 ] := ADR ( BoundMenuText ) ;
	assignv	MenuCodeArray,BoundMenuKeys	; MenuCodeArray [ 0 ] := ADR ( BoundMenuKeys )
	assignv	MenuServArray,BoundMenuServ	; MenuServArray [ 0 ] := ADR ( BoundMenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	rcall	CloseMenuLevel			; CloseMenuLevel ( ) ;
	ret					;END (* ModiBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DisplayNumber :					;PROCEDURE DisplayNumber ( ) ;
;**************					;VAR
;						; Ch[param] : CHAR ;
;						;BEGIN (* DisplayNumber *)
	lds	param,Number			; SendSerial ( Number [ 0 ] ) ;
	rcall	SendSerial			;
	lds	param,Number+1			; SendSerial ( Number [ 1 ] ) ;
	rcall	SendSerial			;
	lds	param,Number+2			; SendSerial ( Number [ 2 ] ) ;
	rcall	SendSerial			;
	lds	param,Number+3			; Ch := Number [ 3 ] ;
	cpi	param,' '			; IF Ch = ' ' THEN
	brne	DisNu_0				; BEGIN
	ldi	param,'0'			;  Ch := '0' ;
DisNu_0 :					; END (* IF *) ;
	rcall	SendSerial			; SendSerial ( Ch ) ;
	ldi	param,'.'			; SendSerial ( '.' ) ;
	rcall	SendSerial			;
	lds	param,Number+4			; SendSerial ( Number [ 4 ] ) ;
	rcall	SendSerial			;
	ret					;END (* DisplayNumber *) ;
;-----------------------------------------------------------------------------
DispLoBoundOptSrv :				;PROCEDURE DispLoBoundOptSrv ( ) ;
;******************				;BEGIN (* DispLoBoundOptSrv *)
	ldz	LoBoundPrompt<<1		; SendSerialFlashTxt ( LoBoundPrompt ) ;
	rcall	SendSerialFlashTxt		;
	ldz	LowerBound			; WordToString ( LowerBound , Number , 5 , ' ' ) ;
	ldx	Number				;
	ldi	param,5				;
	ldi	acc,' '				;
	rcall	WordToString			;
	rcall	DisplayNumber			; DisplayNumber ( ) ;
	rcall	NewLine				; NewLine ( ) ;
	ret					;END (* DispLoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DispUpBoundOptSrv :				;PROCEDURE DispUpBoundOptSrv ( ) ;
;******************				;BEGIN (* DispUpBoundOptSrv *)
	ldz	UpBoundPrompt<<1		; SendSerialFlashTxt ( UpBoundPrompt ) ;
	rcall	SendSerialFlashTxt		;
	ldz	UpperBound			; WordToString ( UpperBound , Number , 5 , ' ' ) ;
	ldx	Number				;
	ldi	param,5				;
	ldi	acc,' '				;
	rcall	WordToString			;
	rcall	DisplayNumber			; DisplayNumber ( ) ;
	rcall	NewLine				; NewLine ( ) ;
	ret					;END (* DispUpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DispBoundOptSrv :				;PROCEDURE DispBoundOptSrv ( ) ;
;****************				;BEGIN (* DispBoundOptSrv *)
	rcall	DispLoBoundOptSrv		; DispLoBoundOptSrv ( ) ;
	rcall	DispUpBoundOptSrv		; DispUpBoundOptSrv ( ) ;
	rcall	NewLine				; NewLine ( ) ;
	ret					;END (* DispBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DefaultParamOptSrv :				;PROCEDURE DefaultParamOptSrv ( ) ;
;*******************				;BEGIN (* DefaultParamOptSrv *)
	rcall	SetDefaltParam			; SetDefaltParam ( ) ;
	rcall	DispBoundOptSrv			; DispBoundOptSrv ( ) ;
	ret					;END (* DefaultParamOptSrv *) ;
;-----------------------------------------------------------------------------
SaveParOptSrv :					;PROCEDURE SaveParOptSrv ( ) ;
;**************					;BEGIN (* SaveParOptSrv *)
;	...
	ret					;END (* SaveParOptSrv *) ;
;-----------------------------------------------------------------------------
ModiLoBoundOptSrv :				;PROCEDURE ModiLoBoundOptSrv ( ) ;
;******************				;BEGIN (* ModiLoBoundOptSrv *)
	rcall	OpenMenuLevel			; OpenMenuLevel ( ) ;
	assignv	MenuTextEntry,LoUpBoMenuText	; MenuTextEntry [ 0 ] := ADR ( LoUpBoMenuText ) ;
	assignv	MenuCodeArray,LoBodMenuKeys	; MenuCodeArray [ 0 ] := ADR ( LoBodMenuKeys )
	assignv	MenuServArray,LoBoMenuServ	; MenuServArray [ 0 ] := ADR ( LoBoMenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	rcall	CloseMenuLevel			; CloseMenuLevel ( ) ;
	ret					;END (* ModiLoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
ModiUpBoundOptSrv :				;PROCEDURE ModiUpBoundOptSrv ( ) ;
;******************				;BEGIN (* ModiUpBoundOptSrv *)
	rcall	OpenMenuLevel			; OpenMenuLevel ( ) ;
	assignv	MenuTextEntry,LoUpBoMenuText	; MenuTextEntry [ 0 ] := ADR ( LoUpBoMenuText ) ;
	assignv	MenuCodeArray,UpBodMenuKeys	; MenuCodeArray [ 0 ] := ADR ( UpBodMenuKeys )
	assignv	MenuServArray,UpBoMenuServ	; MenuServArray [ 0 ] := ADR ( UpBoMenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	rcall	CloseMenuLevel			; CloseMenuLevel ( ) ;
	ret					;END (* ModiUpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
IncLoBoundOptSrv :				;PROCEDURE IncLoBoundOptSrv ( ) ;
;*****************				;BEGIN (* IncLoBoundOptSrv *)
	incvar	LowerBound,1			; LowerBound := LowerBound + 1 ;
	rcall	DispLoBoundOptSrv		; DispLoBoundOptSrv ( ) ;
	ret					;END (* IncLoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
Inc10LoBoundOptSrv :				;PROCEDURE Inc10LoBoundOptSrv ( ) ;
;*******************				;BEGIN (* Inc10LoBoundOptSrv *)
	incvar	LowerBound,10			; LowerBound := LowerBound + 10 ;
	rcall	DispLoBoundOptSrv		; DispLoBoundOptSrv ( ) ;
	ret					;END (* Inc10LoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DecLoBoundOptSrv :				;PROCEDURE DecLoBoundOptSrv ( ) ;
;*****************				;BEGIN (* DecLoBoundOptSrv *)
	decvar	LowerBound,1			; LowerBound := LowerBound - 1 ;
	rcall	DispLoBoundOptSrv		; DispLoBoundOptSrv ( ) ;
	ret					;END (* DecLoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
Dec10LoBoundOptSrv :				;PROCEDURE Dec10LoBoundOptSrv ( ) ;
;*******************				;BEGIN (* Dec10LoBoundOptSrv *)
	decvar	LowerBound,10			; LowerBound := LowerBound - 10 ;
	rcall	DispLoBoundOptSrv		; DispLoBoundOptSrv ( ) ;
	ret					;END (* Dec10LoBoundOptSrv *) ;
;-----------------------------------------------------------------------------
IncUpBoundOptSrv :				;PROCEDURE IncUpBoundOptSrv ( ) ;
;*****************				;BEGIN (* IncUpBoundOptSrv *)
	incvar	UpperBound,1			; UpperBound := UpperBound + 1 ;
	rcall	DispUpBoundOptSrv		; DispUpBoundOptSrv ( ) ;
	ret					;END (* IncUpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
Inc10UpBoundOptSrv :				;PROCEDURE Inc10UpBoundOptSrv ( ) ;
;*******************				;BEGIN (* Inc10UpBoundOptSrv *)
	incvar	UpperBound,10			; UpperBound := UpperBound + 10 ;
	rcall	DispUpBoundOptSrv		; DispUpBoundOptSrv ( ) ;
	ret					;END (* Inc10UpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
DecUpBoundOptSrv :				;PROCEDURE DecUpBoundOptSrv ( ) ;
;*****************				;BEGIN (* DecUpBoundOptSrv *)
	decvar	UpperBound,1			; UpperBound := UpperBound - 1 ;
	rcall	DispUpBoundOptSrv		; DispUpBoundOptSrv ( ) ;
	ret					;END (* DecUpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
Dec10UpBoundOptSrv :				;PROCEDURE Dec10UpBoundOptSrv ( ) ;
;*******************				;BEGIN (* Dec10UpBoundOptSrv *)
	decvar	UpperBound,10			; UpperBound := UpperBound - 10 ;
	rcall	DispUpBoundOptSrv		; DispUpBoundOptSrv ( ) ;
	ret					;END (* Dec10UpBoundOptSrv *) ;
;-----------------------------------------------------------------------------
OpenMenuLevel	:				;PROCEDURE OpenMenuLevel ( ) ;
;****************				;BEGIN (* OpenMenuLevel *)
	cpyword	MenuTextEntry+4			; MenuTextEntry [ 3 ] := MenuTextEntry [ 2 ] ;
	cpyword	MenuTextEntry+2			; MenuTextEntry [ 2 ] := MenuTextEntry [ 1 ] ;
	cpyword	MenuTextEntry			; MenuTextEntry [ 1 ] := MenuTextEntry [ 0 ] ;
	cpyword	MenuCodeArray+4			; MenuCodeArray [ 3 ] := MenuCodeArray [ 2 ] ;
	cpyword	MenuCodeArray+2			; MenuCodeArray [ 2 ] := MenuCodeArray [ 1 ] ;
	cpyword	MenuCodeArray			; MenuCodeArray [ 1 ] := MenuCodeArray [ 0 ] ;
	cpyword	MenuServArray+4			; MenuServArray [ 3 ] := MenuServArray [ 2 ] ;
	cpyword	MenuServArray+2			; MenuServArray [ 2 ] := MenuServArray [ 1 ] ;
	cpyword	MenuServArray			; MenuServArray [ 1 ] := MenuServArray [ 0 ] ;
	ret					;END OpenMenuLevel ;
;-----------------------------------------------------------------------------
CloseMenuLevel	:				;PROCEDURE CloseMenuLevel ( ) ;
;****************				;VAR
;						; Inx[acc] : BYTE ;
;						; ScrPtr[x] : POINTER TO CHAR ;
;						; DstPtr[z] : POINTER TO CHAR ;
;						;BEGIN (* CloseMenuLevel *)
	ldz	MenuTextEntry			; DstPtr := ADR ( MenuTextEntry [ 0 ] ) ;
	ldx	MenuTextEntry+2			; SrcPtr := ADR ( MenuTextEntry [ 1 ] ) ;
	ldi	acc,0				; FOR Inx := 0 TO 5 DO
CloMeLu_0 :					; BEGIN
	ld	acc2,x+				;  DstPtr ^ := SrcPtr ^ ;
	st	z+,acc2				;  DstPtr := DstPtr + 1 ;
						;  SrcPtr := SrcPtr + 1 ;
	inc	acc				; END (* FOR *) ;
	cpi	acc,6				;
	brne	CloMeLu_0			;
	ldz	MenuCodeArray			; DstPtr := ADR ( MenuCodeArray [ 0 ] ) ;
	ldx	MenuCodeArray+2			; SrcPtr := ADR ( MenuCodeArray [ 1 ] ) ;
	ldi	acc,0				; FOR Inx := 0 TO 5 DO
CloMeLu_1 :					; BEGIN
	ld	acc2,x+				;  DstPtr ^ := SrcPtr ^ ;
	st	z+,acc2				;  DstPtr := DstPtr + 1 ;
						;  SrcPtr := SrcPtr + 1 ;
	inc	acc				; END (* FOR *) ;
	cpi	acc,6				;
	brne	CloMeLu_1			;
	ldz	MenuServArray			; DstPtr := ADR ( MenuServArray [ 0 ] ) ;
	ldx	MenuServArray+2			; SrcPtr := ADR ( MenuServArray [ 1 ] ) ;
	ldi	acc,0				; FOR Inx := 0 TO 5 DO
CloMeLu_2 :					; BEGIN
	ld	acc2,x+				;  DstPtr ^ := SrcPtr ^ ;
	st	z+,acc2				;  DstPtr := DstPtr + 1 ;
						;  SrcPtr := SrcPtr + 1 ;
	inc	acc				; END (* FOR *) ;
	cpi	acc,6				;
	brne	CloMeLu_2			;
	ret					;END CloseMenuLevel ;
;-----------------------------------------------------------------------------
SetupService :					;PROCEDURE SetupService ( ) ;
;*************					;BEGIN (* SetupService *)
	assignv	MenuTextEntry,SetupMenuText	; MenuTextEntry [ 0 ] := ADR ( SetupMenuText ) ;
	assignv	MenuCodeArray,SetupMenuKeys	; MenuCodeArray [ 0 ] := ADR ( SetupMenuKeys )
	assignv	MenuServArray,SetupMenuServ	; MenuServArray [ 0 ] := ADR ( SetupMenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	ret					;END SetupService ;
;-----------------------------------------------------------------------------
ResetProcessor :				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
						;BEGIN (* Main *)
	rcall	ClearRAM			; ClearRAM ( ) ;
	rcall	ClearRegs			; ClearRegs ( ) ;
	rcall	HardwareInit			; HardwareInit ( ) ;
	rcall	EnvirInit			; EnvirInit ( ) ;
	rcall	SoftwareInit			; SoftwareInit ( ) ;
	sei					; EI ( ) ;
	ldz	HelloText<<1			; SendSerialFlashTxt ( HelloText ) ;
	rcall	SendSerialFlashTxt		;
Main_0	:					; LOOP
Main_1	:					;  REPEAT
	rcall	SerialDataPresent		;  UNTIL SerialDataPresent ( ) ;
	brcc	Main_1				;
	ldz	StartInfoText<<1		;  SendSerialFlashTxt ( StartInfoText ) ;
	rcall	SendSerialFlashTxt		;
	rcall	GetSerial			;  ? := GetSerial ( ) ;
	rcall	SetupService			;  SetupService ( ) ;
	ldz	StopInfoText<<1			;  SendSerialFlashTxt ( StopInfoText ) ;
	rcall	SendSerialFlashTxt		;
	ldz	HelloText2<<1			;  SendSerialFlashTxt ( HelloText2 ) ;
	rcall	SendSerialFlashTxt		;
	rjmp	Main_0				; END (* LOOP *) ;
						;END (* Main *).
;-----------------------------------------------------------------------------
HelloText:		.db	Cr,Lf,Cr,Lf,"Witaj!",Cr,Lf
HelloText2:		.db	"Dowolny klawisz aktywuje menu",Cr,Lf,0
StartInfoText:		.db	"Startuje menu",Cr,Lf,Cr,Lf,0
StopInfoText:		.db	"Koniec menu",Cr,Lf,Cr,Lf,0
LoBoundPrompt:		.db	"Dolna granica =",0
UpBoundPrompt:		.db	"Gorna granica =",0
;-----------------------------------------------------------------------------
SetupMenuText :	.db	"Opcje menu :",Cr,Lf
		.db	"  0 - Wyswietl granice",Cr,Lf
		.db	"  1 - Modyfikacja granic",Cr,Lf
		.db	"  2 - Parametry domyslne",Cr,Lf
		.db	"  3 - Zachowaj parametry",Cr,Lf
		.db	"Esc - Koniec",Cr,Lf,0,0
SetupMenuKeys :	.db	'1' , '2'			; inx=0	inx=1
		.db	'3' , '0'			; inx=2 inx=3
		.db	0xFF, 0xFF			; 
SetupMenuServ :	.dw	ModiBoundOptSrv			; inx=0
		.dw	DefaultParamOptSrv		; inx=1
		.dw	SaveParOptSrv			; inx=2
	 	.dw	DispBoundOptSrv			; inx=3
;-----------------------------------------------------------------------------
BoundMenuText :	.db	" Modyfikacja granic zakresow :",Cr,Lf
		.db	"  a - modyfikacja granicy dolnej",Cr,Lf
		.db	"  b - modyfikacja granicy gornej",Cr,Lf
		.db	"Esc - Koniec",Cr,Lf,0,0
BoundMenuKeys :	.db	'a' , 'A'			; inx=0	inx=1
		.db	'b' , 'B'			; inx=2	inx=3
		.db	0xFF , 0xFF			;
BoundMenuServ :	.dw	ModiLoBoundOptSrv		; inx=0
		.dw	ModiLoBoundOptSrv		; inx=1
		.dw	ModiUpBoundOptSrv		; inx=2
		.dw	ModiUpBoundOptSrv		; inx=3
;-----------------------------------------------------------------------------
LoUpBoMenuText:	.db	"  Modyfikacja granic",Cr,Lf
		.db	"   0 - wyswietl aktualna wartosc",Cr,Lf
		.db	"   1 - zwieksz o 0.1",Cr,Lf
		.db	"   2 - zwieksz o 1",Cr,Lf
		.db	"   3 - zmniejsz o 0.1 ",Cr,Lf
		.db	"   4 - zmniejsz o 1 ",Cr,Lf
		.db	" Esc - Koniec",Cr,Lf,0
LoBodMenuKeys :	.db	'0' , '1'			; inx=0	inx=1
		.db	'2' , '3'			; inx=2 inx=3
		.db	'4' , 0xFF			; inx=4
LoBoMenuServ :	.dw	DispLoBoundOptSrv		; inx=0
		.dw	IncLoBoundOptSrv		; inx=1
		.dw	Inc10LoBoundOptSrv		; inx=2
		.dw	DecLoBoundOptSrv		; inx=3
		.dw	Dec10LoBoundOptSrv		; inx=4
;-----------------------------------------------------------------------------
UpBodMenuKeys :	.db	'0' , '1'			; inx=0	inx=1
		.db	'2' , '3'			; inx=2 inx=3
		.db	'4' , 0xFF			; inx=4
UpBoMenuServ :	.dw	DispUpBoundOptSrv		; inx=0
		.dw	IncUpBoundOptSrv		; inx=1
		.dw	Inc10UpBoundOptSrv		; inx=2
		.dw	DecUpBoundOptSrv		; inx=3
		.dw	Dec10UpBoundOptSrv		; inx=4
;-----------------------------------------------------------------------------
.exit
