;
;*******************************************************
;*******************************************************
;**                                                   **
;**   Program prezentacji obslugi wielopoziomowego    **
;**                    menu                           **
;**                                                   **
;**         Andrzej Pawluczuk                         **
;**                                                   **
;**         Mikrokontroler: ATMEGA8515                **
;**                                                   **
;**             Bialystok, 2006                       **
;**                                                   **
;*******************************************************
;*******************************************************
;
	.nolist
;*******************************************************
.include "m8515def.inc"
;*******************************************************
	.list
	.listmac
;-----------------------------------------------------------------------------
.macro	ldz
	ldi	zl,low(@0)
	ldi	zh,high(@0)
.endm
;-----------------------------------------------------------------------------
.macro	ldx
	ldi	xl,low(@0)
	ldi	xh,high(@0)
.endm
;-----------------------------------------------------------------------------
.macro	pushz
	push	zl
	push	zh
.endm
;-----------------------------------------------------------------------------
.macro	popz
	pop	zh
	pop	zl
.endm
;-----------------------------------------------------------------------------
.macro	pushf
	push	acc
	in	acc,sreg
	push	acc
.endm
;-----------------------------------------------------------------------------
.macro	popf
	pop	acc
	out	sreg,acc
	pop	acc
.endm
;-----------------------------------------------------------------------------
.macro	pushvar
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	ld	acc,z+				;
	ld	acc2,z				;
	push	acc2				;
	push	acc				;
.endm
;-----------------------------------------------------------------------------
.macro	popvar
	pop	acc				;
	pop	acc2				;
	ldi	zl,low(@0)			;
	ldi	zh,high(@0)			;
	st	z+,acc				;
	st	z,acc2				;
.endm
;-----------------------------------------------------------------------------
.macro	WriFTxt
	ldi	zl,low(@0<<1)			;
	ldi	zh,high(@0<<1)			;
	rcall	SendSerialFlashTxt		;
.endm
;-----------------------------------------------------------------------------
.macro	SetMEnt
	ldi	zl,low(MenuTextEntry)		;
	ldi	zh,high(MenuTextEntry)		;
	ldi	acc,low(@0<<1)			;
	st	z+,acc				;
	ldi	acc,high(@0<<1)			;
	st	z,acc				;
.endm
;-----------------------------------------------------------------------------
.macro	SetCEnt
	ldi	zl,low(MenuCodeArray)		;
	ldi	zh,high(MenuCodeArray)		;
	ldi	acc,low(@0<<1)			;
	st	z+,acc				;
	ldi	acc,high(@0<<1)			;
	st	z,acc				;
.endm
;-----------------------------------------------------------------------------
.macro	SetSEnt
	ldi	zl,low(MenuServiceArray)	;
	ldi	zh,high(MenuServiceArray)	;
	ldi	acc,low(@0<<1)			;
	st	z+,acc				;
	ldi	acc,high(@0<<1)			;
	st	z,acc				;
.endm
;-----------------------------------------------------------------------------
.def acc		= r16
.def acc2		= r17
.def param		= r18
;-----------------------------------------------------------------------------
.equ		Stand_TIMSK	=	0b00000010
;	Timer/counter Interrupt Mask	  ||| | |
;					  ||| | +--- TOIE0 : Timer/Counter 0 Overflow Interrupt Enable
;					  ||| +----- TICIE1 : Timer/Counter1 Input Capture Interrupt Enable
;					  ||+------- OCIE1B : Timer/counter1 Output Compare B Match Interrupt Enable
;					  |+-------- OCE1A : Timer/counter1 Output Compare A Match Interrupt Enable
;					  +--------- TOIE1 : Timer/Counter1 Overflow Interrupt Enable
;-----------------------------------------------------------------------------
.equ		Stand_TCCR0	=	0b00000011
;	Timer/Counter0 Control Register	       |||
;					       ||+-- CS00
;					       |+--- CS01
;					       +---- CS02
;		CS02	CS01	CS00
;		0	0	0	timer/counter0 is stopped
;		0	0	1	clk
;		0	1	0	clk/8
;		0	1	1	clk/64
;		1	0	0	clk/256
;		1	0	1	clk/1024
;		1	1	0	external pin T0; falling edge
;		1	1	1	external pin T0; rising edge
;-----------------------------------------------------------------------------
.equ		Stand_PADir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PAData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PBDir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PBData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PCDir	=	0b11111111
;					  ||||||||
;					  |||||||+-- output : 
;					  ||||||+--- output : 
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PCData	=	0b11111111
;-----------------------------------------------------------------------------
.equ		Stand_PDDir	=	0b11111110
;					  ||||||||
;					  |||||||+-- input :	[RXD]
;					  ||||||+--- output :	[TXD]
;					  |||||+---- output : 
;					  ||||+----- output : 
;					  |||+------ output : 
;					  ||+------- output : 
;					  |+-------- output : 
;					  +--------- output : 
.equ		Stand_PDData	=	0b11111111
;-----------------------------------------------------------------------------
	.dseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  DATA  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
;					;CONST
.equ	Cr		= 0x0D		; Cr = 0x0D ;
.equ	Lf		= 0x0A		; Lf = 0x0A ;
.equ	Esc		= 0x1B		; Esc = 0x1B ;
;					;
;					;VAR
MenuTextEntry :		.byte	2	; MenuTextEntry : POINTER TO CHAR ;
MenuCodeArray :		.byte	2	; MenuCodeArray : POINTER TO CHAR ;
MenuServiceArray :	.byte	2	; MenuServiceArray : POINTER TO PROCEDURE ( ) ;
RedisplayMenu :		.byte	1	; RedisplayMenu : BOOLEAN ;
;-----------------------------------------------------------------------------
	.cseg
;*******************************************************
;*******************************************************
;**                                                   **
;**                  CODE  SEGMENT                    **
;**                                                   **
;*******************************************************
;*******************************************************
	.org	0				;
	rjmp	ResetProcessor			;
;-----------------------------------------------------------------------------
	.org	INT0addr			;External Interrupt0 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT1addr			;External Interrupt1 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ICP1addr			;Input Capture1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Aaddr			;Output Compare1A Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC1Baddr			;Output Compare1B Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF1addr			;Overflow1 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OVF0addr			;Overflow0 Interrupt Vector Address
	rjmp	TC0OvfInterrupt			;
;-----------------------------------------------------------------------------
	.org	SPIaddr				;SPI Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	URXCaddr			;USART Receive Complete Interrupt Vector Address
	rjmp	USARTRXDInterrupt		;
;-----------------------------------------------------------------------------
	.org	UDREaddr			;USART Data Register Empty Interrupt Vector Address
	rjmp	USARTDataRegEmptInterrupt	;
;-----------------------------------------------------------------------------
	.org	UTXCaddr			;USART Transmit Complete Interrupt Vector Address
	rjmp	USARTTXDInterrupt		;
;-----------------------------------------------------------------------------
	.org	ACIaddr				;Analog Comparator Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	INT2addr			;External Interrupt2 Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	OC0addr				;Output Compare0 Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	ERDYaddr			;EEPROM Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
	.org	SPMaddr				;SPM complete Interrupt Vector Address
	reti					;
;-----------------------------------------------------------------------------
.include "util.inc"
;-----------------------------------------------------------------------------
.equ	USART_Speed	= 47	; USART BAUD Rate Generator fosc=7.3728 MHz , 9600 bps
.equ	USART_LED_Trace	= 1
.equ	TXDBuffSize	= 32
.equ	RXDBuffSize	= 16
.equ	RXDLED		= 7
.equ	TXDLED		= 6
.equ	USARTTracePort	= PORTD
.equ	LEDOnState	= 0
.include "usartlib.inc"
;-----------------------------------------------------------------------------
HardwareInit :					;PROCEDURE HardwareInit ;
;*************					;BEGIN
	ldi	acc,Stand_TIMSK			; [TIMSK] := Stand_TIMSK ;
	out	TIMSK,acc			;
	ldi	acc,Stand_TCCR0			; [TCCR0] := Stand_TCCR0 ;
	out	TCCR0,acc			;
	ret					;END (* HardwareInit *) ;
;-----------------------------------------------------------------------------
EnvirInit :					;PROCEDURE EnvirInit ;
;**********					;BEGIN
	ldi	acc,Stand_PADir			; [DDRA] := Stand_PADir ;
	out	DDRA,Acc			;
	ldi	acc,Stand_PAData		; [PORTA] := Stand_PAData ;
	out	PORTA,acc			;
	ldi	acc,Stand_PBDir			; [DDRB] := Stand_PBDir ;
	out	DDRB,Acc			;
	ldi	acc,Stand_PBData		; [PORTB] := Stand_PBData ;
	out	PORTB,acc			;
	ldi	acc,Stand_PCDir			; [DDRC] := Stand_PCDir ;
	out	DDRC,Acc			;
	ldi	acc,Stand_PCData		; [PORTC] := Stand_PCData ;
	out	PORTC,acc			;
	ldi	acc,Stand_PDDir			; [DDRD] := Stand_PDDir ;
	out	DDRD,Acc			;
	ldi	acc,Stand_PDData		; [PORTD] := Stand_PDData ;
	out	PORTD,acc			;
	ldz	USART_Speed			; USARTHardwareInit ( USART_Speed ) ;
	rcall	USARTHardwareInit		;
	ret					;END (* EnvirInit *) ;
;-----------------------------------------------------------------------------
SoftwareInit :					;PROCEDURE SoftwareInit ;
;*************					;BEGIN
	ret					;END (* SoftwareInit *) ;
;-----------------------------------------------------------------------------
TC0OvfInterrupt :				;PROCEDURE TC0OvfInterrupt ;
;****************				;BEGIN
	pushf					;
	pushz					;
.if USART_LED_Trace == 1
	rcall	USARTTimeService		; USARTTimeService ( ) ;
.endif
	popz					;
	popf					;
	reti					;END (* TC0OvfInterrupt *) ;
;-----------------------------------------------------------------------------
InputKey :					;FUNCTION InputKey ( ) : CHAR ;
;***************				;BEGIN (* InputKey *)
InpKy_1	:					; REPEAT
	rcall	SerialDataPresent		; UNTIL SerialDataPresent ( ) ;
	brcc	InpKy_1				;
	rcall	GetSerial			; InputKey := GetSerial ( ) ;
	ret					;END InputKey ;
;-----------------------------------------------------------------------------
NewLine		:				;PROCEDURE NewLine ( ) ;
;****************				;BEGIN (* NewLine *)
	ldi	param,Cr			; SendSerial ( Cr ) ;
	rcall	SendSerial			;
	ldi	param,Lf			; SendSerial ( Lf ) ;
	rcall	SendSerial			;
	ret					;END NewLine ;
;-----------------------------------------------------------------------------
EscapeKey :					;PROCEDURE EscapeKey ( Key[param] : CHAR ) : BOOLEAN ;
;**********					;BEGIN (* EscapeKey *)
	cpi	param,Esc			; IF Key = Esc THEN
	brne	EsKe_0				; BEGIN
	sec					;  RETURN TRUE ;
	ret					;
EsKe_0	:					; END (* IF *) ;
	clc					; RETURN FALSE ;
	ret					;END EscapeKey ;
;-----------------------------------------------------------------------------
EnterKey :					;PROCEDURE EnterKey ( Key[param] : CHAR ) : BOOLEAN ;
;*********					;BEGIN (* EnterKey *)
	cpi	param,Cr			; IF Key = Cr THEN
	brne	EnKe_0				;
	sec					;  RETURN TRUE ;
	ret					;
EnKe_0	:					; END (* IF *) ;
	clc					; RETURN FALSE ;
	ret					;END EnterKey ;
;-----------------------------------------------------------------------------
FindByteInArr :					;PROCEDURE FindByteInArr ( Data [param] : BYTE ;
;****************			   	;		Array [z] : ARRAY OF BYTE ) : BYTE[acc] ;
;						;VAR
;						; Loop[acc2] : BYTE ;
;						; Ch[acc] : CHAR ;
;						;BEGIN (* FindByteInArr *)
	clr	acc2				; Loop := 0 ;
FiByIA_2 :					; REPEAT
	lpm					;  Ch := Array [ Loop ] ;
	mov	acc,r0				;
	cpi	acc,0xFF			;  IF Ch = 0x0FF THEN
	brne	FiByIA_0			;  BEGIN
	ldi	acc,0xFF			;   RETURN 0xFF ;
	ret					;
FiByIA_0 :					;  END (* IF *) ;
	cp	acc,param			;  IF Ch = Data THEN
	brne	FiByIA_1			;  BEGIN
	mov	acc,acc2			;   RETURN Loop ;
	ret					;
FiByIA_1 :					;  END (* IF *) ;
	adiw	zl,1				;
	inc	acc2				;
	rjmp	FiByIA_2			; UNTIL FALSE ;
						;END (* FindByteInArr *) ;
;-----------------------------------------------------------------------------
RunService :					;PROCEDURE RunService ( Inx [param] ; BYTE :
;****************				;			Serv [z] : ADDRESS ) ;
;						;BEGIN (* RunService *)
	lsl	param				; Serv [ Inx ] ( ) ;
	clr	acc				;
	add	zl,param			;
	adc	zh,acc				;
	lpm					;
	push	r0				;
	adiw	zl,1				;
	lpm					;
	mov	zh,r0				;
	pop	zl				;
	icall					;
	ret					;END (* RunService *) ;
;-----------------------------------------------------------------------------
RunMenuSerivce	:				;PROCEDURE RunMenuSerivce ( ) ;
;****************				;BEGIN (* RunMenuSerivce *)
	ldi	acc,1				; RedisplayMenu := TRUE ;
	sts	RedisplayMenu,acc		;
RuMeSe_0 :					; LOOP
	lds	acc,RedisplayMenu		;  IF RedisplayMenu THEN
	cpi	acc,0				;
	breq	RuMeSe_2			;  BEGIN
	ldx	MenuTextEntry			;   SendSerialFlashTxt ( MenuTextEntry [ 0 ] ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	rcall	SendSerialFlashTxt		;
	rcall	NewLine				;   NewLine ( ) ;
	ldi	acc,0				;   RedisplayMenu := FALSE ;
	sts	RedisplayMenu,acc		;
RuMeSe_2 :					;  END (* IF *) ;
	rcall	InputKey			;  Ch = InputKey ( ) ;
	mov	param,acc			;  IF EscapeKey ( Ch ) THEN
	rcall	EscapeKey			;
	brcc	RuMeSe_1			;  BEGIN
	ret					;   ETURN ;
RuMeSe_1 :					;  END (* IF *) ;
	ldx	MenuCodeArray			;  Inx = FindByteInArr ( Ch , MenuCodeArray ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	rcall	FindByteInArr			;
	cpi	acc,0xFF			;  IF Inx <> 0xFF THEN
	breq	RuMeSe_3			;  EGIN
	ldx	MenuServiceArray		;   RunService ( Inx , MenuServiceArray ^ ) ;
	ld	zl,x+				;
	ld	zh,x				;
	mov	param,acc			;
	rcall	RunService			;
	ldi	acc,1				;   RedisplayMenu := TRUE ;
	sts	RedisplayMenu,acc		;
RuMeSe_3 :					;  END (* IF *) ;
	rjmp	RuMeSe_0			; END (* LOOP *) ;
	ret					;END RunMenuSerivce ;
;-----------------------------------------------------------------------------
Lv3MenuOption0Serv :				;PROCEDURE Lv3MenuOption0Serv ( ) ;
;*******************				;BEGIN (* Lv3MenuOption0Serv *)
	WriFTxt	Option1_0Text			; WriteFlashText ( Option1_0Text ) ;
	ret					;END (* Lv3MenuOption0Serv *) ;
;-----------------------------------------------------------------------------
Lv3MenuOption1Serv :				;PROCEDURE Lv3MenuOption1Serv ( ) ;
;*******************				;BEGIN (* Lv3MenuOption1Serv *)
	WriFTxt	Option1_1Text			; WriteFlashText ( Option1_1Text ) ;
	ret					;END (* Lv3MenuOption1Serv *) ;
;-----------------------------------------------------------------------------
Lv3MenuOption2Serv :				;PROCEDURE Lv3MenuOption2Serv ( ) ;
;*******************				;BEGIN (* Lv3MenuOption2Serv *)
	WriFTxt	Option1_2Text			; WriteFlashText ( Option1_2Text ) ;
	ret					;END (* Lv3MenuOption2Serv *) ;
;-----------------------------------------------------------------------------
Gl0MenuOption0Serv :				;PROCEDURE Gl0MenuOption0Serv ( ) ;
;*******************				;BEGIN (* Gl0MenuOption0Serv *)
	WriFTxt	Option0_0Text			; WriteFlashText ( Option0_0Text ) ;
	ret					;END (* Gl0MenuOption0Serv *) ;
;-----------------------------------------------------------------------------
Gl0MenuOption1Serv :				;PROCEDURE Gl0MenuOption1Serv ( ) ;
;*******************				;BEGIN (* Gl0MenuOption1Serv *)
	WriFTxt	Option0_1Text			; WriteFlashText ( Option0_1Text ) ;
	ret					;END (* Gl0MenuOption1Serv *) ;
;-----------------------------------------------------------------------------
Gl0MenuOption2Serv :				;PROCEDURE Gl0MenuOption2Serv ( ) ;
;*******************				;BEGIN (* Gl0MenuOption2Serv *)
	WriFTxt	Option0_2Text			; WriteFlashText ( Option0_2Text ) ;
	ret					;END (* Gl0MenuOption2Serv *) ;
;-----------------------------------------------------------------------------
Gl0MenuOption3Serv :				;PROCEDURE Gl0MenuOption3Serv ( ) ;
;*******************				;BEGIN (* Gl0MenuOption3Serv *)
	WriFTxt	Option0_3Text			; WriteFlashText ( Option0_3ext ) ;
	ret					;END (* Gl0MenuOption3Serv *) ;
;-----------------------------------------------------------------------------
Gl3MenuOption0Serv :				;PROCEDURE Gl3MenuOption0Serv ( ) ;
;*******************				;BEGIN (* Gl3MenuOption0Serv *)
	WriFTxt	Option3_0Text			; WriteFlashText ( Option3_0Text ) ;
	ret					;END (* Gl3MenuOption0Serv *) ;
;-----------------------------------------------------------------------------
Gl3MenuOption1Serv :				;PROCEDURE Gl3MenuOption1Serv ( ) ;
;*******************				;BEGIN (* Gl3MenuOption1Serv *)
	WriFTxt	Option3_1Text			; WriteFlashText ( Option3_1Text ) ;
	ret					;END (* Gl3MenuOption1Serv *) ;
;-----------------------------------------------------------------------------
Gl3MenuOption2Serv :				;PROCEDURE Gl3MenuOption2Serv ( ) ;
;*******************				;BEGIN (* Gl3MenuOption2Serv *)
	WriFTxt	Option3_2Text			; WriteFlashText ( Option3_2Text ) ;
	ret					;END (* Gl3MenuOption2Serv *) ;
;-----------------------------------------------------------------------------
Gl3MenuOption3Serv :				;PROCEDURE Gl3MenuOption3Serv ( ) ;
;*******************				;BEGIN (* Gl3MenuOption3Serv *)
	WriFTxt	Option3_3Text			; WriteFlashText ( Option3_3Text ) ;
	ret					;END (* Gl3MenuOption3Serv *) ;
;-----------------------------------------------------------------------------
Gl0MenuOption4Serv :				;PROCEDURE Gl0MenuOption4Serv ( ) ;
;*******************				;BEGIN (* Gl0MenuOption4Serv *)
	pushvar	MenuTextEntry			; PushVar ( MenuTextEntry ) ;
	pushvar	MenuCodeArray			; PushVar ( MenuCodeArray ) ;
	pushvar	MenuServiceArray		; PushVar ( MenuServiceArray ) ;
	SetMEnt	Lv3Option4SubmenuTxt		; SetMenuEntry ( Lv3Option4SubmenuTxt ) ;
	SetCEnt Lv3Option4SubmenuKeys		; SetCodeEntry ( Lv3Option4SubmenuKeys ) ;
	SetSEnt	Lv3Option4SubmenuServ		; SetServiceEntry ( Lv3Option4SubmenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	popvar	MenuServiceArray		; PopVar ( MenuServiceArray ) ;
	popvar	MenuCodeArray			; PopVar ( MenuCodeArray ) ;
	popvar	MenuTextEntry			; PopVar ( MenuTextEntry ) ;
	ret					;END (* Gl0MenuOption4Serv *) ;
;-----------------------------------------------------------------------------
GlobalMenuOption3Srv :				;PROCEDURE GlobalMenuOption3Srv ( ) ;
;*******************				;BEGIN (* GlobalMenuOption3Srv *)
	pushvar	MenuTextEntry			; PushVar ( MenuTextEntry ) ;
	pushvar	MenuCodeArray			; PushVar ( MenuCodeArray ) ;
	pushvar	MenuServiceArray		; PushVar ( MenuServiceArray ) ;
	SetMEnt	GlOption3SubmenuTxt		; SetMenuEntry ( GlOption3SubmenuTxt ) ;
	SetCEnt GlOption3SubmenuKeys		; SetCodeEntry ( GlOption3SubmenuKeys ) ;
	SetSEnt	GlOption3SubmenuServ		; SetServiceEntry ( GlOption3SubmenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	popvar	MenuServiceArray		; PopVar ( MenuServiceArray ) ;
	popvar	MenuCodeArray			; PopVar ( MenuCodeArray ) ;
	popvar	MenuTextEntry			; PopVar ( MenuTextEntry ) ;
	ret					;END GlobalMenuOption3Srv ;
;-----------------------------------------------------------------------------
GlobalMenuOption2Srv :				;PROCEDURE GlobalMenuOption2Srv ( ) ;
;*********************				;BEGIN (* GlobalMenuOption2Srv *)
	WriFTxt	Option2Text			; WriteFlashText ( Option2Text ) ;
	ret					;END GlobalMenuOption2Srv ;
;-----------------------------------------------------------------------------
GlobalMenuOption1Srv :				;PROCEDURE GlobalMenuOption1Srv ( ) ;
;****************				;BEGIN (* GlobalMenuOption1Srv *)
	WriFTxt	Option1Text			; WriteFlashText ( Option1Text ) ;
	ret					;END GlobalMenuOption1Srv ;
;-----------------------------------------------------------------------------
GlobalMenuOption0Srv :				;PROCEDURE GlobalMenuOption0Srv ( ) ;
;****************				;BEGIN (* GlobalMenuOption0Srv *)
	pushvar	MenuTextEntry			; PushVar ( MenuTextEntry ) ;
	pushvar	MenuCodeArray			; PushVar ( MenuCodeArray ) ;
	pushvar	MenuServiceArray		; PushVar ( MenuServiceArray ) ;
	SetMEnt	GlOption0SubmenuTxt		; SetMenuEntry ( GlOption0SubmenuTxt ) ;
	SetCEnt GlOption0SubmenuKeys		; SetCodeEntry ( GlOption0SubmenuKeys ) ;
	SetSEnt	GlOption0SubmenuServ		; SetServiceEntry ( GlOption0SubmenuServ ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	popvar	MenuServiceArray		; PopVar ( MenuServiceArray ) ;
	popvar	MenuCodeArray			; PopVar ( MenuCodeArray ) ;
	popvar	MenuTextEntry			; PopVar ( MenuTextEntry ) ;
	ret					;END GlobalMenuOption0Srv ;
;-----------------------------------------------------------------------------
SetupService :					;PROCEDURE SetupService ( ) ;
;*************					;BEGIN (* SetupService *)
	SetMEnt	GlogalMenuText			; SetMenuEntry ( GlogalMenuText ) ;
	SetCEnt GlobalMenuKeys			; SetCodeEntry ( GlobalMenuKeys ) ;
	SetSEnt	GlobalMenuService		; SetServiceEntry ( GlobalMenuService ) ;
	rcall	RunMenuSerivce			; RunMenuSerivce ( ) ;
	ret					;END SetupService ;
;-----------------------------------------------------------------------------
ResetProcessor :				;
	ldi	acc,HIGH(RAMEND)		;
	out	SPH,acc				;
	ldi	acc,LOW(RAMEND)			;
	out	SPL,acc				;
						;BEGIN (* Main *)
	rcall	ClearRAM			; ClearRAM ( ) ;
	rcall	ClearRegs			; ClearRegs ( ) ;
	rcall	HardwareInit			; HardwareInit ( ) ;
	rcall	EnvirInit			; EnvirInit ( ) ;
	rcall	SoftwareInit			; SoftwareInit ( ) ;
	sei					; EI ( ) ;
	WriFTxt	HelloText			; WriteFlashText ( HelloText ) ;
Main_0	:					; LOOP
Main_1	:					;  REPEAT
	rcall	SerialDataPresent		;  UNTIL SerialDataPresent ( ) ;
	brcc	Main_1				;
	WriFTxt	StartInfoText			;  WriteFlashText ( StartInfoText ) ;
	rcall	GetSerial			;  ? := GetSerial ( ) ;
	rcall	SetupService			;  SetupService ( ) ;
	WriFTxt	StopInfoText			;  WriteFlashText ( StopInfoText ) ;
	WriFTxt	HelloText2			;  WriteFlashText ( HelloText2 ) ;
	rjmp	Main_0				; END (* LOOP *) ;
						;END (* Main *).
;-----------------------------------------------------------------------------
HelloText:		.db	Cr,Lf,Cr,Lf,"Witaj!",Cr,Lf
HelloText2:		.db	"Dowolny klawisz aktywuje menu",Cr,Lf,0
StartInfoText:		.db	"Startuje menu",Cr,Lf,Cr,Lf,0
StopInfoText:		.db	"Koniec menu",Cr,Lf,Cr,Lf,0
;-----------------------------------------------------------------------------
GlogalMenuText :	.db	"Menu: poziom glowny ",Cr,Lf
			.db	"  0 - >>> Opcja 0 <<< (---> podmenu)",Cr,Lf
			.db	"  1 - >>> Opcja 1 <<< ",Cr,Lf
			.db	"  2 - >>> Opcja 2 <<< ",Cr,Lf
			.db	"  3 - >>> Opcja 3 <<< (---> podmenu)",Cr,Lf
			.db	"Esc - Koniec.",Cr,Lf,0
GlobalMenuKeys :	.db	'0' , '1'		; inx=0	inx=1
			.db	'2' , '3'		; inx=2	inx=3
			.db	0xFF,0
GlobalMenuService :	.dw	GlobalMenuOption0Srv	; inx=0
			.dw	GlobalMenuOption1Srv	; inx=1
			.dw	GlobalMenuOption2Srv	; inx=2
			.dw	GlobalMenuOption3Srv	; inx=3
Option1Text :		.db	Cr,Lf,"**** Obsluga opcji G-1 ****",Cr,Lf,Cr,Lf,0
Option2Text :		.db	Cr,Lf,"**** Obsluga opcji G-2 ****",Cr,Lf,Cr,Lf,0
;-----------------------------------------------------------------------------
GlOption0SubmenuTxt :	.db	"Podmenu opcji globalnej 0 ",Cr,Lf
			.db	"      0 - >>> Opcja 0-0 <<< ",Cr,Lf
			.db	"      1 - >>> Opcja 0-1 <<< ",Cr,Lf
			.db	"      2 - >>> Opcja 0-2 <<< ",Cr,Lf
			.db	"      3 - >>> Opcja 0-3 <<< ",Cr,Lf
			.db	"      4 - >>> Opcja 0-4 <<< (---> podmenu)",Cr,Lf
			.db	"    Esc - Koniec.",Cr,Lf,0
GlOption0SubmenuKeys :	.db	'0' , '1'		; inx=0	inx=1
			.db	'2' , '3'		; inx=2	inx=3
			.db	'4' , 0xFF		; inx=4
GlOption0SubmenuServ :	.dw	Gl0MenuOption0Serv	; inx=0
			.dw	Gl0MenuOption1Serv	; inx=1
			.dw	Gl0MenuOption2Serv	; inx=2
			.dw	Gl0MenuOption3Serv	; inx=3
			.dw	Gl0MenuOption4Serv	; inx=4
Option0_0Text :		.db	Cr,Lf,"**** Obsluga opcji 0-0 ****",Cr,Lf,Cr,Lf,0
Option0_1Text :		.db	Cr,Lf,"**** Obsluga opcji 0-1 ****",Cr,Lf,Cr,Lf,0
Option0_2Text :		.db	Cr,Lf,"**** Obsluga opcji 0-2 ****",Cr,Lf,Cr,Lf,0
Option0_3Text :		.db	Cr,Lf,"**** Obsluga opcji 0-3 ****",Cr,Lf,Cr,Lf,0
;-----------------------------------------------------------------------------
GlOption3SubmenuTxt :	.db	"Podmenu opcji globalnej 3 ",Cr,Lf
			.db	"      0 - >>> Opcja 3-0 <<< ",Cr,Lf
			.db	"      1 - >>> Opcja 3-1 <<< ",Cr,Lf
			.db	"      2 - >>> Opcja 3-2 <<< ",Cr,Lf
			.db	"      3 - >>> Opcja 3-3 <<< ",Cr,Lf
			.db	"    Esc - Koniec.",Cr,Lf,0
GlOption3SubmenuKeys :	.db	'0' , '1'		; inx=0	inx=1
			.db	'2' , '3'		; inx=2	inx=3
			.db	0xFF, 0			;
GlOption3SubmenuServ :	.dw	Gl3MenuOption0Serv	; inx=0
			.dw	Gl3MenuOption1Serv	; inx=1
			.dw	Gl3MenuOption2Serv	; inx=2
			.dw	Gl3MenuOption3Serv	; inx=3
Option3_0Text :		.db	Cr,Lf,"**** Obsluga opcji 3-0 ****",Cr,Lf,Cr,Lf,0
Option3_1Text :		.db	Cr,Lf,"**** Obsluga opcji 3-1 ****",Cr,Lf,Cr,Lf,0
Option3_2Text :		.db	Cr,Lf,"**** Obsluga opcji 3-2 ****",Cr,Lf,Cr,Lf,0
Option3_3Text :		.db	Cr,Lf,"**** Obsluga opcji 3-3 ****",Cr,Lf,Cr,Lf,0
;-----------------------------------------------------------------------------
Lv3Option4SubmenuTxt :	.db	"Kolejne podmenu ",Cr,Lf
			.db	"              0 - >>> Opcja 3-0 <<< ",Cr,Lf
			.db	"              1 - >>> Opcja 3-1 <<< ",Cr,Lf
			.db	"              2 - >>> Opcja 3-2 <<< ",Cr,Lf
			.db	"            Esc - Koniec",Cr,Lf,0,0
Lv3Option4SubmenuKeys :	.db	'0' , '1'		; inx=0	inx=1
			.db	'2' , 0xFF		; inx=2
Lv3Option4SubmenuServ :	.dw	Lv3MenuOption0Serv	; inx=0
			.dw	Lv3MenuOption1Serv	; inx=1
			.dw	Lv3MenuOption2Serv	; inx=2
Option1_0Text :		.db	Cr,Lf,"**** Obsluga podopcji 0-4-0 ****",Cr,Lf,Cr,Lf,0,0
Option1_1Text :		.db	Cr,Lf,"**** Obsluga podopcji 0-4-1 ****",Cr,Lf,Cr,Lf,0,0
Option1_2Text :		.db	Cr,Lf,"**** Obsluga podopcji 0-4-2 ****",Cr,Lf,Cr,Lf,0,0
;-----------------------------------------------------------------------------
.exit
