;
;*******************************************************
;*******************************************************
;**                                                   **
;**  Biblioteka procedur obslugi operacji na          **
;**            lancuchach znakowych                   **
;**                                                   **
;**            Andrzej Pawluczuk                      **
;**                                                   **
;**           Mikrokontroler: AVR                     **
;**                                                   **
;**             Bialystok, 2006                       **
;**                                                   **
;*******************************************************
;*******************************************************
;
.message	"***>>> Dolaczenie bibioteki obslugi ciagow znakowych"
;
;*******************************************************
;*******************************************************
;
;
;
;-----------------------------------------------------------------------------
StrCpy	:					;PROCEDURE StrCpy ( DestStr[x] : POINTER TO CHAR ;
;*************					;		    SrcStr[z] : POINTER TO CHAR ) ;
;						;			DestStr --> RAM
;						;			SrcStr  --> RAM
;						;VAR
;						; Ch[acc] : CHAR ;
;						;BEGIN (* StrCpy *)
CtrCp_0	:					; LOOP
	ld	acc,z+				;  Ch := SrcStr ^ ;
						;  SrcStr := SrcStr + 1 ;
	st	x+,acc				;  DestStr ^ := Ch ;
						;  DestStr := DestStr + 1 ;
	cpi	acc,0				;  IF Ch = 0 THEN
	brne	CtrCp_0				;  BEGIN
	ret					;   RETURN ;
						;  END (* IF *) ;
						; END (* LOOP *) ;
						;END (* StrCpy *) ;
;-----------------------------------------------------------------------------
StrCopyFlash :					;PROCEDURE StrCopyFlash ( DestStr[x] : POINTER TO CHAR ;
;*************					;			  SrcStr[z] : POINTER TO CHAR ) ;
;						;				DestStr --> RAM
;						;				SrcStr  --> FLASH
;						;VAR
;						; Ch[r0] : CHAR ;
;						;BEGIN (* StrCopyFlash *)
StrFCp_0 :					; LOOP
	lpm					;  Ch := SrcStr ^ ;
	st	x+,r0				;  DestStr ^ := Ch ;
						;  DestStr := DestStr + 1 ;
	adiw	zl,1				;  SrcStr := SrcStr + 1 ;
	or	r0,r0				;  IF Ch = CHR ( 0 ) THEN
	brne	StrFCp_0			;  BEGIN
						;   EXIT ;
						;  END (* IF *) ;
						; END (* LOOP *) ;
	ret					;END (* StrCopyFlash *) ;
;-----------------------------------------------------------------------------
StrLen	:					;FUNCTION StrLen ( Str[z] : ARRAY OF CHAR ) : WORD[x] ;
;********					;VAR
;						; Lgt[x] : WORD ;
;						; Ch[acc] : CHAR ;
;						;BEGIN (* StrLen *)
	ldi	acc,0				; Lgt := 0 ;
	mov	xl,acc				;
	mov	xh,acc				;
StrLg_0	:					; LOOP
	ld	acc,z+				;  Ch := Str ^ ;
						;  Str := Str + 1 ;
	cpi	acc,0				;  IF Ch = 0 THEN
	brne	StrLg_1				;  BEGIN
	ret					;   StrLen := Lgt ;
						;   RETURN ;
StrLg_1	:					;  END (* IF *) ;
	adiw	xl,1				;  Lgt := Lgt + 1 ;
	rjmp	StrLg_0				; END (* LOOP *) ;
						;END (* StrLen *) ;
;-----------------------------------------------------------------------------
StrDelete :					;PROCEDURE StrDelete ( String[z] : ARRAY OF CHAR ;
;**********					;		       ChPos[param] : BYTE ;
;						;		       Cnt[acc] : BYTE ) ;
;						;VAR
;						; InStr[z] : ^ CHAR ;
;						; OutStr[x] : ^ CHAR ;
;						; Ch[acc2] : CHAR ;
;						;BEGIN (* StrDelete *)
	ldi	acc2,0				; OutStr := ADR ( String [ 0 ] ) + ChPos ;
	mov	xl,zl				;
	mov	xh,zh				;
	add	xl,param			;
	adc	xh,acc2				;
	add	zl,param			; InStr := ADR ( String [ 0 ] ) + ChPos + Cnt ;
	adc	zh,acc2				;
	add	zl,acc				;
	adc	zh,acc2				;
StrDel_0 :					; LOOP
	ld	acc2,z+				;  Ch := InStr ^ ;
						;  InStr := InStr + 1 ;
	st	x+,acc2				;  OutStr ^ := Ch ;
						;  OutStr := OutStr + 1 ;
	cpi	acc2,0				;  IF Ch = 0 THEN
	brne	StrDel_0			;  BEGIN
	ret					;   RETURN ;
						;  END (* IF *) ;
						; END (* LOOP *) ;
						;END (* StrDelete *) ;
;-----------------------------------------------------------------------------
BegOfString :					;PROCEDURE BegOfString ( String[z] : POINTER TO CHAR ) : POINTER TO CHAR[z] ;
;************					;VAR
;						; Inx : BYTE ;
;						;BEGIN (* BegOfString *)
BeOfStr_1 :					; FOR Inx := 0 TO <duzo> DO
						;  BEGIN
	ld	acc,z				;   IF String [ Inx ] <> ' ' THEN
	cpi	acc,' '				;
	breq	BeOfStr_0			;    BEGIN
	ret					;     RETURN ADR ( String [ Inx ] ) ;
BeOfStr_0 :					;    END (* IF *) ;
	adiw	zl,1				;
	rjmp	BeOfStr_1			;  END (* FOR *) ;
						;END (* BegOfString *) ;
;-----------------------------------------------------------------------------
EndOfString :					;PROCEDURE EndOfString ( String[z] : ARRAY OF CHAR ) : POINTER TO CHAR[z] ;
;************					;VAR
;						; Inx : BYTE ;
;						;BEGIN (* EndOfString *)
EnOfStr_1 :					; FOR Inx := 0 TO <duzo> DO
						;  BEGIN
	ld	acc,z				;   IF String [ Inx ] = 0 THEN
	cpi	acc,0				;
	brne	EnOfStr_0			;    BEGIN
	ret					;     RETURN ADR ( String [ Inx ] ;
EnOfStr_0 :					;    END (* IF *) ;
	adiw	zl,1				;
	rjmp	EnOfStr_1			;  END (* FOR *) ;
						;END (* EndOfString *) ;
;-----------------------------------------------------------------------------
AppendString :					;PROCEDURE AppendString
;*************					;   ( DestString[z] : ARRAY OF CHAR ;
;						;     AppString[x] : POINTER TO CHAR[z] ) ;
;						;BEGIN (* AppendString *)
	push	xl				;
	push	xh				;
	rcall	EndOfString			; StrCpy ( EndOfString ( DestString ) ,
	mov	xl,zl				;          AppString ) ;
	mov	xh,zh				;
	pop	zh				;
	pop	zl				;
	rcall	StrCpy				;
	ret					;END (* AppendString *) ;
;-----------------------------------------------------------------------------
AppendStringFlash :				;PROCEDURE AppendStringFlash
;******************				;   ( DestString[z] : ARRAY OF CHAR ;
;						;     AppString[x] : POINTER TO CHAR[z] ) ;
;						;BEGIN (* AppendStringFlash *)
	push	xl				;
	push	xh				;
	rcall	EndOfString			; StrCopyFlash ( EndOfString ( DestString ) ,
	mov	xl,zl				;                AppString ) ;
	mov	xh,zh				;
	pop	zh				;
	pop	zl				;
	rcall	StrCopyFlash			;
	ret					;END (* AppendStringFlash *) ;
;-----------------------------------------------------------------------------
AppendChar :					;PROCEDURE AppendChar
;***********					;   ( DestString[z] : ARRAY OF CHAR ;
;						;     Char[param] : CHAR ) ;
;						;VAR
;						; EndStr : POINTER TO CHAR ;
;						;BEGIN (* AppendChar *)
	rcall	EndOfString			; EndStr := EndOfString ( DestString ) ;
	st	z+,param			; EndStr ^ := Char ;
						; EndStr := EndStr + 1 ;
	ldi	acc,0				; EndStr ^ := 0 ;
	st	z,acc				;
	ret					;END (* AppendChar *) ;
;-----------------------------------------------------------------------------
StrInsertCh :					;PROCEDURE StrInsertCh
;***********					;   ( DestString[z] : ARRAY OF CHAR ;
;						;     InsCh[param] : CHAR ;
;						;     Pos[acc] : BYTE ) ;
;						;VAR
;						; OutStr[x] : POINTER TO CHAR ;
;						; InStr[z] : POINTER TO CHAR ;
;						; Counter[acc2] : BYTE ;
;						;BEGIN (* StrInsertCh *)
	push	acc				;
	mov	xl,zl				; OutStr := ADR ( DestString [ 0 ] ) + Pos ;
	mov	xh,zh				;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	ldi	acc2,1				; Counter := 1 ;
StrInsCh_0 :					; WHILE OutStr ^ <> 0 DO
	ld	acc,x				;
	cpi	acc,0				;
	breq	StrInsCh_1			; BEGIN
	adiw	xl,1				;  OutStr := OutStr + 1 ;
	inc	acc2				;  Counter := Counter + 1 ;
	rjmp	StrInsCh_0			;
StrInsCh_1 :					; END (* WHILE *) ;
	push	zl				;
	push	zh				;
	mov	zl,xl				; InStr = OutStr ;
	mov	zh,xh				;
	adiw	xl,1				; OutStr := OutStr + 1 ;
StrInsCh_2 :					; LOOP
	ld	acc,z				;  OutStr ^ := InStr ^ ;
	st	x,acc				;
	ldi	acc,0xFF			;  OutStr := OutStr - 1 ;
	add	xl,acc				;
	adc	xh,acc				;
	add	zl,acc				;  InStr := InStr - 1 ;
	adc	zh,acc				;
	dec	acc2				;  Counter := Counter - 1 ;
	brne	StrInsCh_2			; END (* LOOP *) ;
	pop	xh				; OutStr := ADR ( DestString [ 0 ] ) + Pos ;
	pop	xl				;
	pop	acc				;
	add	xl,acc				;
	ldi	acc,0				;
	adc	xh,acc				;
	st	x,param				; OutStr ^ := InsCh ;
	ret					;END (* StrInsertCh *) ;
;-----------------------------------------------------------------------------
StrNorm :					;PROCEDURE StrNorm ( String[z] : ARRAY OF CHAR ) ;
;********					;VAR
;						; Str[z] : POINTER TO CHAR ;
;						;BEGIN (* StrNorm *)
	push	zl				;
	push	zh				;
	ld	acc,z				; IF String ^ = ' ' THEN
	cpi	acc,' '				;
	brne	StrNo_0				; BEGIN
	mov	xl,zl				;  StrCpy ( String , BegOfString ( String ) ) ;
	mov	xh,zh				;
	rcall	BegOfString			;
	rcall	StrCpy				;
StrNo_0	:					; END (* IF *) ;
	pop	zh				;
	pop	zl				;
	ld	acc,z				; IF String ^ <> 0 THEN
	cpi	acc,0				;
	breq	StrNo_1				; BEGIN
	rcall	EndOfString			;  Str := EndOfString ( String ) ;
StrNo_2	:					;  REPEAT
	ldi	acc,0				;   Str ^ := 0 ;
	st	z,acc				;
	ldi	acc,0xFF			;   Str := Str - 1 ;
	add	zl,acc				;
	adc	zh,acc				;
	ld	acc,z				;  UNTIL Str ^ <> ' ' ;
	cpi	acc,' '				;
	breq	StrNo_2				;
StrNo_1	:					; END (* IF *) ;
	ret					;END (* StrNorm *) ;
;-----------------------------------------------------------------------------
StrExtract :					;PROCEDURE StrExtract ( VAR SubStr[x] : ARRAY OF CHAR ;
;***********					;                           String[z] : ARRAY OF CHAR ;
;						;			    ChPos[acc] : BYTE ;
;						;		            Cnt[param] : BYTE ) ;
;						;VAR
;						; Str[z] : POINTER TO CHAR ;
;						; Ch[acc] : CHAR ;
;						;BEGIN (* StrExtract *)
	add	zl,acc				; Str := ADR ( String [ 0 ] ) + ChPos ;
	ldi	acc,0				;
	adc	zh,acc				;
StrExt_2 :					; LOOP
	ld	acc,z+				;  Ch := Str ^ ;
						;  Str := Str + 1 ;
	st	x+,acc				;  SubStr ^ := Ch ;
						;  SubStr := SubStr + 1 ;
	cpi	acc,0				;  IF Ch = 0 THEN
	brne	StrExt_0			;  BEGIN
	ret					;   RETURN ;
StrExt_0 :					;  END (* IF *) ;
	dec	param				;  Cnt := Cnt - 1 ;
						;  IF Cnt = 0 THEN
	brne	StrExt_1			;  BEGIN
	st	x,param				;   SubStr ^ := 0 ;
	ret					;   RETURN ;
StrExt_1 :					;  END (* IF *) ;
	rjmp	StrExt_2			; END (* LOOP *) ;
						;END (* StrExtract *) ;
;-----------------------------------------------------------------------------
CapChar :					;FUNCTION CapChar ( Ch[acc] : CHAR ) : CHAR[acc] ;
;********					;BEGIN (* CapChar *)
	cpi	acc,'a'				; IF Ch < 'a' THEN
	brcc	CapCh_0				; BEGIN
	ret					;  CapChar := Ch ;
						;  RETURN ;
CapCh_0	:					; END (* IF *) ;
	cpi	acc,'z'+1			; IF Ch < 'z' THEN
	brcc	CapCh_1				; BEGIN
	subi	acc,0x20			;  Ch := Ch - 0x20 ;
CapCh_1	:					; END (* IF *) ;
						; CapChar := Ch ;
	ret					;END (* CapChar *) ;
;-----------------------------------------------------------------------------
StrComp	:					;FUNCTION StrComp ( String[x] : ARRAY OF CHAR ;
;********					;                   Pattern[z] : ARRAY OF CHAR ;
;						;                   Size[param] : BYTE ;
;						;		    Upcased[acc] : BOOLEAN ) : SIGNED BYTE[acc] ;
;						;	StrComp = -1 -> String[x] < Pattern[z]
;						;	StrComp = 0  -> String[x] = Pattern[z]
;						;	StrComp = 1  -> String[x] > Pattern[z]
;						;VAR
;						; Ch1[acc] : CHAR ;
;						; Ch2[acc2] : CHAR ;
;						;BEGIN (* StrComp *)
	cpi	acc,0				; IF Upcased THEN
	breq	Strcmp_0			; BEGIN
Strcmp_15 :					;  WHILE Size <> 0 DO
	cpi	param,0				;
	breq	Strcmp_11			;  BEGIN
	ld	acc,z+				;   Ch2 := CapChar ( Pattern ^ ) ;
						;   Pattern := Pattern + 1 ;
	rcall	CapChar				;
	mov	acc2,acc			;
	ld	acc,x+				;   Ch1 := CapChar ( String ^ ) ;
						;   String := String + 1 ;
	rcall	CapChar				;
	cpi	acc,0				;   IF ( Ch1 = 0 ) OR ( Ch2 = 0 ) THEN
	breq	Strcmp_12			;
	cpi	acc2,0				;
	brne	Strcmp_13			;
Strcmp_12 :					;   BEGIN
	ldi	acc,0				;    StrComp := 0 ;
	ret					;    RETURN ;
Strcmp_13 :					;   END (* IF *) ;
	cp	acc,acc2			;   IF Ch1 <> Ch2 THEN
	breq	Strcmp_14			;   BEGIN
						;    IF Ch1 > Ch2 THEN
	brcs	Strcmp_16			;    BEGIN
	ldi	acc,1				;     StrComp := 1 ;
	ret					;     RETURN ;
						;    END (* IF ... *)
Strcmp_16 :					;    ELSE
						;    BEGIN
	ldi	acc,0xFF			;     StrComp := -1 ;
	ret					;     RETURN ;
						;    END (* IF ... ELSE *) ;
Strcmp_14 :					;   END (* IF *) ;
	dec	param				;   Size := Size - 1 ;
	rjmp	Strcmp_15			;
Strcmp_11 :					;  END (* WHILE *) ;
	ldi	acc,0				;  StrComp := 0 ;
	ret					;  RETURN ;
Strcmp_0 :					; END (* IF *) ;
Strcmp_5 :					; WHILE Size <> 0 DO
	cpi	param,0				;
	breq	Strcmp_1			; BEGIN
	ld	acc,x+				;  Ch1 := String ^ ;
						;  String := String + 1 ;
	ld	acc2,z+				;  Ch2 := Pattern ^ ;
						;  Pattern := Pattern + 1 ;
	cpi	acc,0				;  IF ( Ch1 = 0 ) OR ( Ch2 = 0 ) THEN
	breq	Strcmp_2			;
	cpi	acc2,0				;
	brne	Strcmp_3			;
Strcmp_2 :					;  BEGIN
	ldi	acc,0				;   StrComp := 0 ;
	ret					;   RETURN ;
Strcmp_3 :					;  END (* IF *) ;
	cp	acc,acc2			;  IF Ch1 <> Ch2 THEN
	breq	Strcmp_4			;  BEGIN
						;   IF Ch1 > Ch2 THEN
	brcs	Strcmp_6			;   BEGIN
	ldi	acc,1				;    StrComp := 1 ;
	ret					;    RETURN ;
						;   END (* IF ... *)
Strcmp_6 :					;   ELSE
						;   BEGIN
	ldi	acc,0xFF			;    StrComp := -1 ;
	ret					;    RETURN ;
						;   END (* IF ... ELSE *) ;
Strcmp_4 :					;  END (* IF *) ;
	dec	param				;  Size := Size - 1 ;
	rjmp	Strcmp_5			;
Strcmp_1 :					; END (* WHILE *) ;
	ldi	acc,0				; StrComp := 0 ;
	ret					; RETURN ;
						;END (* StrComp *) ;
;-----------------------------------------------------------------------------
.exit
